
/* Chrysalide - Outil d'analyse de fichiers binaires
 * ##FILE## - traduction d'instructions ARMv7
 *
 * Copyright (C) 2014 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


@title MLS

@encoding(T1) {

    @word 1 1 1 1 1 0 1 1 0 0 0 0 Rn(4) Ra(4) Rd(4) 0 0 0 1 Rm(4)

    @syntax <Rd> <Rn> <Rm> <Ra>

    @conv {

        Rd = Register(Rd)
        Rn = Register(Rn)
        Rm = Register(Rm)
        Ra = Register(Ra)

    }

    @rules {

        //if d IN {13,15} || n IN {13,15} || m IN {13,15} || a IN {13,15} then UNPREDICTABLE

    }

}

@encoding(A1) {

    @word cond(4) 0 0 0 0 0 1 1 0 Rd(4) Ra(4) Rm(4) 1 0 0 1 Rn(4)

    @syntax {c} <Rd> <Rn> <Rm> <Ra>

    @conv {

        c = Condition(cond)
        Rd = Register(Rd)
        Rn = Register(Rn)
        Rm = Register(Rm)
        Ra = Register(Ra)

    }

    @rules {

        //if d == 15 || n == 15 || m == 15 || a == 15 then UNPREDICTABLE;

    }

}
