
/* Chrysalide - Outil d'analyse de fichiers binaires
 * ##FILE## - traduction d'instructions ARMv7
 *
 * Copyright (C) 2014 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


@title MOV (register, Thumb)

@encoding(t1) {

    @half 0 1 0 0 0 1 1 0 D(1) Rm(4) Rd(3)

    @syntax <Rgd> <Rgm>

    @conv {

        Rgd = Register(D:Rd)
        Rgm = Register(Rm)

    }

    @rules {

        //if d == 15 && InITBlock() && !LastInITBlock() then UNPREDICTABLE;

    }

}

@encoding(t2) {

    @half 0 0 0 0 0 0 0 0 0 0 Rm(3) Rd(3)

    @syntax <Rgd> <Rgm>

    @conv {

        S = SetFlags(1)
        Rgd = Register(Rd)
        Rgm = Register(Rm)

    }

    @rules {

        //if InITBlock() then UNPREDICTABLE;

    }

}

@encoding(T3) {

    @word 1 1 1 0 1 0 1 0 0 1 0 S(1) 1 1 1 1 0 0 0 0 Rd(4) 0 0 0 0 Rm(4)

    @syntax {S} <Rgd> <Rgm>

    @conv {

        S = SetFlags(S)
        Rgd = Register(Rd)
        Rgm = Register(Rm)

    }

    @rules {

        //if setflags && (d IN {13,15} || m IN {13,15}) then UNPREDICTABLE;
        //if !setflags && (d == 15 || m == 15 || (d == 13 && m == 13)) then UNPREDICTABLE;

    }

}
