
/* Chrysalide - Outil d'analyse de fichiers binaires
 * ##FILE## - traduction d'instructions ARMv7
 *
 * Copyright (C) 2014 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


@title POP (Thumb)

@encoding(t1) {

    @half 1 0 1 1 1 1 0 P(1) register_list(8)

    @syntax <registers>

    @conv {

        registers = RegistersList(P:'0000000':register_list)

    }

    @rules {

        //if BitCount(registers) < 1 then UNPREDICTABLE;
        //if registers<15> == '1' && InITBlock() && !LastInITBlock() then UNPREDICTABLE;
        if (P == '1') ; chk_call SetInsFlag(AIF_RETURN_POINT)

    }

}

@encoding(T2) {

    @word 1 1 1 0 1 0 0 0 1 0 1 1 1 1 0 1 P(1) M(1) 0 register_list(13)

    @syntax "pop.W" <registers>

    @conv {

        registers = RegistersList(P:M:'0':register_list)

    }

    @rules {

        //if BitCount(registers) < 2 || (P == '1' && M == '1') then UNPREDICTABLE;
        //if registers<15> == '1' && InITBlock() && !LastInITBlock() then UNPREDICTABLE;
        if (P == '1') ; chk_call SetInsFlag(AIF_RETURN_POINT)

    }

}

@encoding(T3) {

    @word 1 1 1 1 1 0 0 0 0 1 0 1 1 1 0 1 Rt(4) 1 0 1 1 0 0 0 0 0 1 0 0

    @syntax "pop.W" <registers>

    @conv {

        Rgt = Register(Rt)
        registers = ListFromRegister(Rgt)

    }

    @rules {

        //if t == 13 || (t == 15 && InITBlock() && !LastInITBlock()) then UNPREDICTABLE;
        if (Rt == '1111') ; chk_call SetInsFlag(AIF_RETURN_POINT)

    }

}
